//ZahlenSpalte_dezimal_501d.js
// 20.01.2019 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Zahlen mit Dezimalstellen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren //////////////////////////
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist ////////////////////////////////////////////
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}
else {
	curDoc = app.documents[0];
}

// den Array der Textrahmen initialisieren
var txtFrameArr = [];

// die Auswahl speichern und prfen
var nTxtFrames = 0;
curSel = app.selection;

if (curSel.length > 0) {
	for (var s=0; s<curSel.length; s++) {
		var curType = curSel[s].constructor.name;
		if (curType == "TextFrame") {
			txtFrameArr.push(curSel[s]);
		}
		else if (curType == "Group") {
			var allItems = curSel[s].allPageItems;
			for (var n=0; n<allItems.length; n++) {
				var curType = allItems[n].constructor.name;
				if (curType == "TextFrame") {
					txtFrameArr.push(allItems[n]);
				}
			}
		}
		else {
			if (curSel[0].hasOwnProperty("baseline")) {
				txtFrameArr.push(curSel[0].parentTextFrames[0]);
			}
		}
	}
	nTxtFrames = txtFrameArr.length;
	if (nTxtFrames == 0) {
		alert ("Die Auswahl enthlt keinen Textrahmen.", "Stop");
		exit();
	}
}
else {
	alert ("Einen leeren Textrahmen auswhlen.", "Stop");
	exit();
}

// das Ergebnis prfen /////////////////////////////////////////////////////////////
if (nTxtFrames > 1) { // wenn mehr als _ein_ Textrahmen gewhlt ist
	alert ("Nur *einen* Textrahmen whlen.", "Achtung");
	exit();
}
else if (nTxtFrames == 1) { // wenn nur _ein_ Textrahmen ausgewhlt ist
	var curFrame = txtFrameArr[0];
	var curCont  = curFrame.parentStory.contents;
	if (curCont.length == 0) { // wenn der Textrahmen leer ist
		// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
		var defStr = getPrefs();
		// wenn die Vorgabendatei existiert, die Werte ausziehen
		if (defStr != "") {
			repDef = defStr.split("\n");
			stVal = repDef[0]*1;
			ndVal = repDef[1]*1;
			dgDec = repDef[2];
			rb01 = rb02 = 0;
			if (dgDec == "0") {
				rb01 = 1;
			}
			else if (dgDec == "1") {
				rb02 = 1;
			}
			spDec = repDef[3];
			rb03 = rb04 = rb05 = 0;
			if (spDec == "0") {
				rb03 = 1;
			}
			else if (spDec == "1") {
				rb04 = 1;
			}
			else if (spDec == "2") {
				rb05 = 1;
			}
			t100 = repDef[4]*1;
			t010 = repDef[5]*1;
			t001 = repDef[6]*1;
			dpDec = repDef[7];
			rb06 = rb07 = 0;
			if (dpDec == "0") {
				rb06 = 1;
			}
			else if (dpDec == "1") {
				rb07 = 1;
			}
			zeDec = repDef[8];
			rb08 = rb09 = 0;
			if (zeDec == "0") {
				rb08 = 1;
			}
			else if (zeDec == "1") {
				rb09 = 1;
			}
			adDec = repDef[9];
			rb10 = rb11 = rb12 = rb13 = 0;
			if (adDec == "0") {
				rb10 = 1;
			}
			else if (adDec == "1") {
				rb11 = 1;
			}
			else if (adDec == "2") {
				rb12 = 1;
			}
			else if (adDec == "3") {
				rb13 = 1;
			}
		}
		else { // wenn keine Vorgabendatei gefunden wurde
			stVal =  1;
			ndVal = 10;
			rb01  =  1;
			rb02  =  0;
			rb03  =  1;
			rb04  =  0;
			t100  =  0;
			t010  =  0;
			t001  =  0;
			rb05  =  0;
			rb06  =  1;
			rb07  =  0;
			rb08  =  1;
			rb09  =  0;
			rb10  =  1;
			rb11  =  0;
			rb12  =  0;
			rb13  =  0;
		}
		
		// die Funktion aufrufen, welche die erste und die letzte Zahl usw. erfragt
		var defNumbers = getNumbers();
		var startVal   = defNumbers[0];
		var stopVal    = defNumbers[1];
		var sepaDec    = defNumbers[2];
		var digiDec    = defNumbers[3]+1;
		var tun1Dec    = defNumbers[4];
		var tun2Dec    = defNumbers[5];
		var tun3Dec    = defNumbers[6];
		var direDec    = defNumbers[7];
		var zeroDec    = defNumbers[8];
		var addiDec    = defNumbers[9];
		
		// die Suchen/Ersetzen-Preferences zurcksetzen ////////////////////////////////////
		app.findTextPreferences = app.changeTextPreferences = null;
		app.findGrepPreferences = app.changeGrepPreferences = null;
		
		// den gewnschten Dezimal-Separatoren bernehmen
		var sepArr  = [".", ","];
		var sepChar = sepArr[sepaDec];
		
		// den Array der Dezimalstellen vorbereiten
		var decArr = [];
		if (digiDec == 1) {
			if (tun1Dec == 0) { // = .0
				var decArr = [sepChar+0];
			}
			else if (tun1Dec == 1) {  // = .1
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n;
				}
			}
			else if (tun1Dec == 2) { // = .2
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n;
					ctr++;
				}
			}
			else if (tun1Dec == 3) { // = .5
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+n;
					ctr++;
				}
			}
		}
		else if (digiDec == 2) {
			if (tun2Dec == 0) { // = .00
				var decArr = [sepChar+"00"];
			}
			else if (tun2Dec == 1) { // = .01
				var decArr = [];
				for (var n=0; n<100; n++) {
					decArr[n] = sepChar+("0"+n).slice(-2);
				}
			}
			else if (tun2Dec == 2) { // = .02
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+2) {
					decArr[ctr] = sepChar+("0"+n).slice(-2);
					ctr++;
				}
			}
			else if (tun2Dec == 3) { // = .05
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+5) {
					decArr[ctr] = sepChar+("0"+n).slice(-2);
					ctr++;
				}
			}
			else if (tun2Dec == 4) { // = .10
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n+"0";
				}
			}
			else if (tun2Dec == 5) { // = .20
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n+"0";
					ctr++;
				}
			}
			else if (tun2Dec == 6) { // = .25
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+25) {
					decArr[ctr] = sepChar+(n+"0").slice(0,2);
					ctr++;
				}
			}
			else if (tun2Dec == 7) { // = .50
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+(n+"0").slice(0,2);
					ctr++;
				}
			}
		}
		else if (digiDec == 3) {
			if (tun3Dec == 0) { // = .000
				var decArr = [sepChar+"000"];
			}
			else if (tun3Dec == 1) { // = .001
				var decArr = [];
				for (var n=0; n<1000; n++) {
					decArr[n] = sepChar+("00"+n).slice(-3);
				}
			}
			else if (tun3Dec == 2) { // = .002
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+2) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 3) { // = .005
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+5) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 4) { // = .010
				var decArr = [];
				for (var n=0; n<100; n++) {
					decArr[n] = sepChar+("0"+n+"0").slice(-3);
				}
			}
			else if (tun3Dec == 5) { // = .020
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+2) {
					decArr[ctr] = sepChar+("0"+n+"0").slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 6) { // = .025
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+25) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 7) {  // = .050
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+50) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			
			
			else if (tun3Dec == 8) { // = .100
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n+"00";
				}
			}
			else if (tun3Dec == 9) { // = .200
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n+"00";
					ctr++;
				}
			}
			else if (tun3Dec == 10) { // = .250
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+250) {
					decArr[ctr] = sepChar+(n+"00").slice(0,3);
					ctr++;
				}
			}
			else if (tun3Dec == 11) {  // = .500
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+(n+"00").slice(0,3);
					ctr++;
				}
			}
		}
		
		var nDec = decArr.length;
		
		if (zeroDec == 1) {
			if (startVal > -1 && stopVal > -1) {
				var nStart = (""+startVal).length;
				var nStop  = (""+stopVal).length; 
				if (nStart != nStop) {
					if (nStop > nStart) {
						nDiff = nStop-nStart;
					}
					else {
						nDiff = nStart-nStop;
					}
				}
				else {
					zeroDec = 0;
				}
			}
			else {
				var startTmp = startVal;
				if (startVal < 0) {
					startTmp = startVal-(startVal*2);
				}
				var stopTmp  = stopVal;
				if (stopVal < 0) {
					stopTmp = stopVal-(stopVal*2);
				}
				if (startTmp<stopTmp) {
					startTmp = stopTmp;
				}
				var nStart = (""+startTmp).length;
				var nStop  = 1;
				nDiff = nStart-nStop;
			}
		}
		if (addiDec == 2 || addiDec == 3) {
			var minusChar = "";
		}
		if (startVal < 0 || stopVal < 0) {
			var minusChar = "";
		}
		if (minusChar == "") {
			if (direDec == 0) {
				direDec = 1;
			}
			else if (direDec == 1) {
				direDec = 0;
			}
		}
		
		// die Auswahl aufheben
		app.selection = null;
		
		// das Separator-Zeichen temporr anders definieren
		if (zeroDec == 1) {
			if (sepChar == "."){
				sepChar = "";
				// die Suchen/Ersetzen-Vorgaben vorbereiten
				app.findTextPreferences.findWhat = ".";
				app.changeTextPreferences.changeTo = "";
			}
		}
		
		// eine Schleife durch die Werte
		if (direDec == 0) { // wenn aufsteigend
			if (addiDec == 0) { // kein Zusatz
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ""+stopVal+decArr[0];
				if (zeroDec == 1) {
					if (sepChar == "") {
						// das Separator-Zeichen temporr auswechseln
						curFrame.parentStory.changeText();
					}
					// die Variable fr die fhrende Null(en) initialisieren
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2$3";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 1) { // Tabulator voranstellen
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 2) { // Minuszeichen voranstellen
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 3) { // Tabulator und Minuszeichen davor
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4$5";
						curFrame.parentStory.changeGrep();
					}
				}
			}
		}
		else if (direDec == 1) { // wenn absteigend
			if (addiDec == 0) { // kein Zusatz
				curFrame.parentStory.insertionPoints.item(-1).contents = (stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>=startVal; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2$3";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 1) { // Tabulator voranstellen
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>=startVal; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 2) { // Minuszeichen voranstellen
				curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>startVal-1; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 3) { // Tabulator und Minuszeichen davor
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>startVal-1; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4$5";
						curFrame.parentStory.changeGrep();
					}
				}
			}
		}
		
		// das temporre "" durch einen Punkt ersetzen
		if (zeroDec == 1) {
			if (sepChar == ""){
				app.findTextPreferences.findWhat = "";
				app.changeTextPreferences.changeTo = ".";
				curFrame.parentStory.changeText();
			}
		}
		
		if (minusChar == "") {
			app.findTextPreferences.findWhat   = "-";
			app.changeTextPreferences.changeTo = "";
			curFrame.parentStory.changeText();
		}
		if (zeroDec == 1) {
			curFrame.parentStory.recompose();
		}
	}
	else {
		alert ("Der Textrahmen muss leer sein.", "Stopp");
		exit();
	}
}

// die Suchen/Ersetzen-Preferences zurcksetzen ////////////////////////////////////
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// das Ende der Aktion verknden ///////////////////////////////////////////////////
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(444);
// das Fenster schliessen
dlog.close();


/////////////////////////////////////////////////////////////////////////////////////
// die Informationen vorbereiten ////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Zahlen_dezimal_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Zahlen_dezimal_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// einen Dialog zeigen (erste Zahl, letzte Zahl usw.) //////////////////////////////
function getNumbers() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  83;
	var labelWidth1 = 162;
	var labelWidth2 = 128;
	var fieldWidth1 =  64;
	var bttnsWidth1 = 124;
	var tuneUnits01 = [".0", ".1", ".2", ".5"];
	var tuneUnits02 = [".00", ".01", ".02", ".05", ".10", ".20", ".25", ".50"];
	var tuneUnits03 = [".000", ".001", ".002", ".005", ".010", ".020", ".025", ".050", ".100", ".200", ".250", ".500"];
	var aDialog = app.dialogs.add({name:"Zahlen-Spalte (nur Ziffern)"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Erste Zahl ", minWidth:labelWidth1});
				var startField = integerEditboxes.add({editValue:stVal, minWidth:fieldWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Letzte Zahl ", minWidth:labelWidth1});
				var stopField = integerEditboxes.add({editValue:ndVal, minWidth:fieldWidth1});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Dezimalseparator ", minWidth:labelWidth2});
						with (sepButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" Punkt", checkedState:rb01, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" Komma", checkedState:rb02});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Nachkommastellen ", minWidth:labelWidth2});
						with (digButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" 1", checkedState:rb03, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" 2", checkedState:rb04});
							radiobuttonControls.add({staticLabel:" 3", checkedState:rb05});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Feinheit ", minWidth:labelWidth0});
						var tuneDropdown100 = dropdowns.add({stringList:tuneUnits01, selectedIndex:t100, minWidth:39});
						staticTexts.add({staticLabel:" (Zehntel)"});
						staticTexts.add({staticLabel:" ", minWidth:34});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						var tuneDropdown010 = dropdowns.add({stringList:tuneUnits02, selectedIndex:t010, minWidth:39});
						staticTexts.add({staticLabel:" (Hundertstel)"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						var tuneDropdown001 = dropdowns.add({stringList:tuneUnits03, selectedIndex:t001, minWidth:39});
						staticTexts.add({staticLabel:" (Tausendstel)"});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Richtung ", minWidth:labelWidth2});
						with (dirButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" aufsteigend", checkedState:rb06, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" absteigend",  checkedState:rb07});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Fhrende Nullen ", minWidth:labelWidth2});
						with (zerButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" nein", checkedState:rb08, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" ja",   checkedState:rb09});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Davorsetzen ", minWidth:labelWidth2});
						with (addButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" nichts",        checkedState:rb10, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" Tabulator",     checkedState:rb11});
							radiobuttonControls.add({staticLabel:" Minuszeichen",  checkedState:rb12});
							radiobuttonControls.add({staticLabel:" Tab und Minus", checkedState:rb13});
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"", minWidth:0});
			}
		}

	}
	// den Dialog anzeigen und auswerten
	if(aDialog.show() == true) {
		var startVal = startField.editValue;
		var stopVal  = stopField.editValue;
		var sepDec   = sepButtns.selectedButton;
		var digDec   = digButtns.selectedButton;
		var tun100   = tuneDropdown100.selectedIndex;
		var tun010   = tuneDropdown010.selectedIndex;
		var tun001   = tuneDropdown001.selectedIndex;
		var dirDec   = dirButtns.selectedButton;
		var zerDec   = zerButtns.selectedButton;
		var addDec   = addButtns.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die Liste der Einstellungen ...
		var prefsArr = [startVal, stopVal, sepDec, digDec, tun100, tun010, tun001, dirDec, zerDec, addDec];
		// ... in eine Textkette verwandeln ...
		var curDef = prefsArr.join("\n");
		// ... zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(curDef);
		// das Ergebnis zum Aufruf zurckschicken
		if (startVal<stopVal) {
			return prefsArr;
		}
		else {
			return [stopVal, startVal, sepDec, digDec, tun100, tun010, tun001, dirDec, zerDec, addDec];
		}
	}
	else {
		aDialog.destroy();
		exit();
	}
}

////////////////////////////////////////////////////////////////////////////////////
// das Ergebnis in eine Datei schreiben ////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Zahlen_dezimal_501.txt");
	}
	else {
		var f = File("~/Library/Preferences/Zahlen_dezimal_501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}